#include "DialogTaskOrder.h"
#include "ui_DialogTaskOrder.h"
#include <QMessageBox>
#include <QJsonDocument>
#include "LAMPWBDDManager.h"

namespace WBFZTASK {
	DialogTaskOrder::DialogTaskOrder(QWidget* parent)
		: QDialog(parent)
		, ui(new Ui::DialogTaskOrder)
	{
		ui->setupUi(this);
		QObject::connect(ui->pushButtonUpdateOrderState, SIGNAL(clicked()), this, SLOT(onpushButtonUpdateOrderState_clicked()));
	}

	DialogTaskOrder::~DialogTaskOrder()
	{}

	void DialogTaskOrder::SetTaskOrder(WBFZTASK::TaskOrder* task)
	{
		this->task = task;
		this->ui->lineEdit_applicant->setText(task->getApplicant());
		this->ui->lineEdit_company->setText(task->getCompany());
		this->ui->lineEdit_contactinfo->setText(task->getContactInfo());
		this->ui->lineEdit_createtime->setText(task->getCreateTime());
		this->ui->lineEdit_ordercode->setText(task->getOrderCode());
		this->ui->lineEdit_orderid->setText(task->getOrderId());
		this->ui->lineEdit_ordermode->setText(task->getOrderMode());
		this->ui->lineEdit_ordersource->setText(task->getOrderSource());
		this->ui->lineEdit_ordertype->setText(task->getOrderType());
		this->ui->lineEdit_updatetime->setText(task->getUpdateTime());
		this->ui->lineEdit_userid->setText(task->getUserId());
		this->ui->plainTextEdit_demand->setPlainText(task->getDemand());
		this->ui->plainTextEdit_intention->setPlainText(task->getIntention());
		this->ui->plainTextEdit_orderdetails->setPlainText(task->getOrderDetails());
		this->ui->plainTextEdit_orderstoreprocess->setPlainText(task->getOrderStoreProcess());
		this->ui->lineEdit_Orderstatus->setText(task->getOrderStatus());
 	}

	void DialogTaskOrder::onpushButtonUpdateOrderState_clicked()
	{
		LAMPWBCONNECT::LAMPWBDDManager::updateTaskoderStatus(this->ui->lineEdit_orderid->text(),
			this->ui->lineEdit_Orderstatus->text()
		);

	}
 

	void DialogTaskOrder::accept() {
		QMessageBox::information(this, u8"Ϣ", u8"Ϣ³ɹ");
	}
}