#pragma once

#ifndef SARUPLOADDIALOG_H
#define SARUPLOADDIALOG_H

#include <QDialog>
#include <QNetworkAccessManager>

class QLineEdit;
class QDateTimeEdit;
class QPushButton;
class QNetworkReply;

class SarUploadDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SarUploadDialog(QWidget* parent = nullptr);
    ~SarUploadDialog();

private slots:
    void onBrowseClicked();
    void onExecuteClicked();
    void handleResponse(QNetworkReply* reply);

private:
    void setupUi();
    void initConnections();
    bool validateInputs();

    // UI Components
    QLineEdit* leFilePath;
    QLineEdit* leDataType;
    QLineEdit* leDataname;
    QDateTimeEdit* dtDatatime;
    QPushButton* btnBrowse;
    QPushButton* btnExecute;
    QPushButton* btnClear;
    QPushButton* btnCancel;

    QNetworkAccessManager* networkManager;
};

#endif // SARUPLOADDIALOG_H
