#pragma once
#ifndef ORDER_H
#define ORDER_H

#include <QString>
#include <qjsonobject.h>
#include <qobject.h>

namespace WBFZTASK {

    enum WBTASKSAPIREQURSTSTATE {
        FAIL,
        SUCCESS,
        ERROR
    };


    class TaskOrder {
    private:
        QString createTime;
        QString orderStatus;
        QString orderId;
        QString orderMode;
        QString ip;
        QString orderDownloadAddr;
        QString userId;
        QString demand;
        QString orderSource;
        QString applicant;
        QString intention;
        QString orderStoreProcess;
        QString orderCode;
        QString qrstCode;
        QString contactInfo;
        QString orderDetails;
        QString company;
        QString dataSize;
        QString updateTime;
        QString orderType;

    public:
        // 캯
        TaskOrder();
        TaskOrder(const QJsonObject& jsonObj);

        // Getter  Setter 
        void setCreateTime(const QString& value);
        QString getCreateTime() const;

        void setOrderStatus(const QString& value);
        QString getOrderStatus() const;

        void setOrderId(QString value);
        QString getOrderId() const;

        void setOrderMode(const QString& value);
        QString getOrderMode() const;

        void setIp(const QString& value);
        QString getIp() const;

        void setOrderDownloadAddr(const QString& value);
        QString getOrderDownloadAddr() const;

        void setUserId(const QString& value);
        QString getUserId() const;

        void setDemand(const QString& value);
        QString getDemand() const;

        void setOrderSource(const QString& value);
        QString getOrderSource() const;

        void setApplicant(const QString& value);
        QString getApplicant() const;

        void setIntention(const QString& value);
        QString getIntention() const;

        void setOrderStoreProcess(const QString& value);
        QString getOrderStoreProcess() const;

        void setOrderCode(const QString& value);
        QString getOrderCode() const;

        void setQrstCode(const QString& value);
        QString getQrstCode() const;

        void setContactInfo(const QString& value);
        QString getContactInfo() const;

        void setOrderDetails(const QString& value);
        QString getOrderDetails() const;

        void setCompany(const QString& value);
        QString getCompany() const;

        void setDataSize(const QString& value);
        QString getDataSize() const;

        void setUpdateTime(const QString& value);
        QString getUpdateTime() const;

        void setOrderType(const QString& value);
        QString getOrderType() const;
    };


    class TaskCollect:public QObject {
    Q_OBJECT    
    private:
            TaskCollect();
        public:    
            void LoadTaskCollect(QJsonDocument& d,QString message);
            void LoadTaskCollectState(QString message);
            static TaskCollect* getInstance();

            int clear();

            int getPagenum();
            int getTotal();
            int getPagecount();
            TaskOrder* getCurrentTaskAt(int i);
        
        signals:
            void updateSIG(WBTASKSAPIREQURSTSTATE state,QString message);


        private:
            QList<TaskOrder> Currnettasklist;
            int pagenum;// ǰpage  ö
            int total;// ܹ
            int pagecount;// ÿҳ
            WBTASKSAPIREQURSTSTATE state;// ״̬
            static TaskCollect* instance;
        };


}

#endif // ORDER_H
 

